/*******************************************************
Chip type               : ATmega8A
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*******************************************************/

#include <mega8.h>
#include <ds3231.h>
#include <alcd.h>
#include <stdio.h>
#include <delay.h>


char display_buffer[17];        /* LCD display buffer for 1 line */
unsigned char hour, min, sec, week_day, day, month, year, msb, lsb;

void main(void)

{
    lcd_init(16);                       //initialize the LCD, 2 rows by 16 columns

    #asm("sei")
   rtc_init(0, 0, 0);                 //initialize the RTC square wave output is disabled SQW/OUT has logic state 0 
   rtc_set_time(12, 48, 55);          // set time 12:00:00 
   rtc_set_date(1, 20, 3, 17);        // set date Saturday 10/05/2014 

    while (1) {
    lcd_clear();
     rtc_get_time(&hour, &min, &sec);                                     //read the time from the RTC
     rtc_get_date(&week_day, &day, &month, &year);                       //read the date from the RTC
     rtc_get_temp(&msb, &lsb); 
     
     sprintf(display_buffer, "%02d:%02d:%02d\n", hour, min, sec);        //display the time on the LCD
     lcd_puts(display_buffer);     
     sprintf(display_buffer, "%02d/%02d/%02d T=%02d.%02d", day, month, year, msb, lsb);        //display the date on the LCD
     lcd_puts(display_buffer); 
     
    delay_ms(500);                                                            //0.5 second delay 
    }

}